#include <stdio.h>
#include <getopt.h>
#include "../include/cpu.h"
#include "../include/help.h"
#include "../include/ide.h"
#include "../include/memory.h"
#include "../include/network.h"
#include "../include/os.h"
#include "../include/partitions.h"
#include "../include/sound.h"
#include "../include/uptime.h"
#include "../include/version.h"
#include "../include/video.h"

void help(int argc, char **argv) {
	puts("");
	printf("Usage: %s [OPTION]...\n", argv[0]);
	printf("Shows information from your computer. Without OPTIONS is the same as with --help.\n\n");
	printf("  -a, --all               displays all the options\n");
	printf("  -c, --cpu               displays info about your processor\n");
	printf("  -i, --ide               displays your ide harddisks and CDROMs\n");
	printf("  -m, --memory            displays info about your RAM and Swap\n");
	printf("  -n, --network           displays network info (card, ips etc.)\n");
	printf("  -o, --operatingsystem   displays what os you're using\n");
	printf("  -p, --partitions        displays your partitions\n");
	printf("  -s, --sound             displays sound info (card(s) etc.)\n");
	printf("  -u, --uptime            displays your uptime\n");
	printf("  -v, --video             displays video information (device(s) etc.)\n");
	printf("  -V, --version           displays the version of this program\n");
	printf("  -h, --help              what you've done now\n\n");
	printf("If something don't work, try it as root.\n");
	printf("Please send bugs reports, comments or ideas to tican@kopervik-online.no or\n");
	printf("contact TiCaN on IRC (Undernet).\n\n");
	exit(0);
}

int main(int argc, char **argv) {
	int option_index=0,current;
	static struct option long_options[] = {
		{"all",0,0,'a'},
		{"cpu",0,0,'c'},
		{"ide",0,0,'i'},
		{"memory",0,0,'m'},
		{"network",0,0,'n'},
		{"operatingsystem",0,0,'o'},
		{"partitions",0,0,'p'},
		{"sound",0,0,'s'},
		{"uptime",0,0,'u'},
		{"video",0,0,'v'},
		{"version",0,0,'V'},
		{"help",0,0,'h'},
		{0,0,0,0}
	};

	current = getopt_long(argc,argv,"acimnopsuvVh",long_options,&option_index);

	switch(current) {
		case 'a':
			cpuinfo();
			video();
			ide();
			memory();
			network();
			os();
			partitions();
			sound();
			uptime();
			video();
			break;
		case 'c':
			cpuinfo();
			break;
		case 'v':
			video();
			break;
		case 'i':
			ide();
			break;
		case 'm':
			memory();
			break;
		case 'n':
			network();
			break;
		case 'o':
			os();
			break;
		case 'p':
			partitions();
			break;
		case 's':
			sound();
			break;
		case 'u':
			uptime();
			break;
		case 'V':
			version();
			break;
		case 'h':
			help(argc,argv);
			break;
		default:
			help(argc,argv);
			break;
	}
	return 0;
}
