#include <stdio.h>
#include <string.h>

void uptime(void) {
	FILE *fd;
	char *fname = "/proc/uptime";
	char buf[50];
	char *s;
	int uptime, days, hours, minutes, seconds;

	fd = fopen(fname, "r");
	if ( !fd ) {
		fprintf(stderr, "Could not open %s. Bailing out.\n", fname);
		return;
	}

	fgets(buf, sizeof buf, fd);
	fclose(fd);

	s = strtok(buf," ");
	uptime = atoi(s);

	days = (uptime / (3600*24));
	hours = (uptime%(3600*24) / 3600);
	minutes = (uptime%(3600*24) % 3600 / 60);
	seconds = (uptime%(3600*24) % 3600 % 60);

	puts("");
	printf("  Uptime:\n  ");

	if ( days > 0 ) {
		printf("%i day%s", days, days == 1?" ":"s ");
	}
	if ( hours > 0 ) {
		if ( hours == 1 ) {
			printf("%i hour ", hours);
		} else {
			printf("%i hours ", hours);
		}
	}
	if ( minutes > 0 ) {
		if ( minutes == 1 ) {
			printf("%i minute ", minutes);
		} else {
			printf("%i minutes ", minutes);
		}
	}
	if ( seconds > 0 ) {
		if ( seconds == 1 ) {
			printf("and %i second", seconds);
		} else {
			printf("and %i seconds", seconds);
		}
	}

	puts("\n");
}
